summaryrefslogtreecommitdiff
path: root/tests/tail-2/inotify-hash-abuse2
diff options
context:
space:
mode:
authorIgor Pashev <pashev.igor@gmail.com>2012-09-09 02:33:07 +0000
committerIgor Pashev <pashev.igor@gmail.com>2012-09-09 02:33:07 +0000
commit8e7ba70eba02f88d4f3ba12e07ab9c7bdf32240a (patch)
tree35373d0bc6f80a2f2ce1c49c91b3817f26b6c465 /tests/tail-2/inotify-hash-abuse2
downloadcoreutils-8e7ba70eba02f88d4f3ba12e07ab9c7bdf32240a.tar.gz
Imported Upstream version 8.17upstream/8.17
Diffstat (limited to 'tests/tail-2/inotify-hash-abuse2')
-rwxr-xr-xtests/tail-2/inotify-hash-abuse239
1 files changed, 39 insertions, 0 deletions
diff --git a/tests/tail-2/inotify-hash-abuse2 b/tests/tail-2/inotify-hash-abuse2
new file mode 100755
index 00000000..eb192a65
--- /dev/null
+++ b/tests/tail-2/inotify-hash-abuse2
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Exercise an abort-inducing flaw in inotify-enabled tail -F.
+# Like inotify-hash-abuse, but without a hard-coded "9".
+
+# Copyright (C) 2009-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ tail
+
+touch f || framework_failure_
+
+debug='---disable-inotify -s .001'
+debug=
+tail $debug -F f & pid=$!
+cleanup_() { kill $pid; }
+
+for i in $(seq 200); do
+ kill -0 $pid || break;
+ mv f g
+ touch f
+done
+
+# Kill the working tail, or fail if it has already aborted
+kill $pid || fail=1
+
+Exit $fail